Loading...
Searching...
No Matches
bbpolytope.h File Reference
`#include "kernel/mod2.h"`
`#include "Singular/ipid.h"`
`#include "gfanlib/gfanlib.h"`

Go to the source code of this file.

## Functions

void | bbpolytope_setup (SModulFunctions *p)
bigintmat * | getFacetNormals (gfan::ZCone *zc)
int | getAmbientDimension (gfan::ZCone *zc)
int | getCodimension (gfan::ZCone *zc)
int | getDimension (gfan::ZCone *zc)
gfan::ZVector | intStar2ZVectorWithLeadingOne (const int d, const int *i)

## Variables

EXTERN_VAR int | polytopeID

## Function Documentation

## bbpolytope_setup()

void bbpolytope_setup | ( | SModulFunctions * | p | ) |

Definition at line 549 of file bbpolytope.cc.

{
blackbox *b=(blackbox*)omAlloc0(sizeof(blackbox));
// all undefined entries will be set to default in setBlackboxStuff
// the default Print is quite usefule,
// all other are simply error messages
b->blackbox_destroy=bbpolytope_destroy;
b->blackbox_String=bbpolytope_String;
//b->blackbox_Print=blackbox_default_Print;
b->blackbox_Init=bbpolytope_Init;
b->blackbox_Copy=bbpolytope_Copy;
b->blackbox_Assign=bbpolytope_Assign;
p->iiAddCproc("gfan.lib","polytopeViaPointsInternal",FALSE,polytopeViaVertices);
p->iiAddCproc("gfan.lib","polytopeViaInequalitiesInternal",FALSE,polytopeViaNormals);
p->iiAddCproc("gfan.lib","verticesInternal",FALSE,vertices);
p->iiAddCproc("gfan.lib","newtonPolytopeInternal",FALSE,newtonPolytope);
p->iiAddCproc("gfan.lib","scalePolytopeInternal",FALSE,scalePolytope);
p->iiAddCproc("gfan.lib","dualPolytopeInternal",FALSE,dualPolytope);
p->iiAddCproc("gfan.lib","mixedVolumeInternal",FALSE,mixedVolume);
/********************************************************/
/* the following functions are implemented in bbcone.cc */
// iiAddCproc("gfan.lib","getAmbientDimensionInternal",FALSE,getAmbientDimension);
// iiAddCproc("gfan.lib","getCodimensionInternal",FALSE,getAmbientDimension);
// iiAddCproc("gfan.lib","getDimensionInternal",FALSE,getDimension);
/********************************************************/
/* the following functions are identical to those in bbcone.cc */
// iiAddCproc("gfan.lib","facetsInternal",FALSE,facets);
// iiAddCproc("gfan.lib","setLinearFormsInternal",FALSE,setLinearForms);
// iiAddCproc("gfan.lib","getLinearFormsInternal",FALSE,getLinearForms);
// iiAddCproc("gfan.lib","setMultiplicityInternal",FALSE,setMultiplicity);
// iiAddCproc("gfan.lib","getMultiplicityInternal",FALSE,getMultiplicity);
// iiAddCproc("gfan.lib","hasFaceInternal",FALSE,hasFace);
/***************************************************************/
// iiAddCproc("gfan.lib","getEquationsInternal",FALSE,getEquations);
// iiAddCproc("gfan.lib","getInequalitiesInternal",FALSE,getInequalities);
polytopeID=setBlackboxStuff(b,"polytope");
//Print("created type %d (polytope)\n",polytopeID);
}
FALSE
#define FALSE
Definition auxiliary.h:97
polytopeViaVertices
BOOLEAN polytopeViaVertices(leftv res, leftv args)
Definition bbpolytope.cc:184
bbpolytope_destroy
void bbpolytope_destroy(blackbox *, void *d)
Definition bbpolytope.cc:101
bbpolytope_String
char * bbpolytope_String(blackbox *, void *d)
Definition bbpolytope.cc:91
polytopeViaNormals
BOOLEAN polytopeViaNormals(leftv res, leftv args)
Definition bbpolytope.cc:330
dualPolytope
BOOLEAN dualPolytope(leftv res, leftv args)
Definition bbpolytope.cc:472
scalePolytope
BOOLEAN scalePolytope(leftv res, leftv args)
Definition bbpolytope.cc:445
polytopeID
VAR int polytopeID
Definition bbpolytope.cc:16
bbpolytope_Init
void * bbpolytope_Init(blackbox *)
Definition bbpolytope.cc:32
bbpolytope_Assign
BOOLEAN bbpolytope_Assign(leftv l, leftv r)
Definition bbpolytope.cc:37
mixedVolume
BOOLEAN mixedVolume(leftv res, leftv args)
Definition bbpolytope.cc:489
newtonPolytope
gfan::ZCone newtonPolytope(poly p, ring r)
Definition bbpolytope.cc:412
vertices
BOOLEAN vertices(leftv res, leftv args)
Definition bbpolytope.cc:369
bbpolytope_Copy
void * bbpolytope_Copy(blackbox *, void *d)
Definition bbpolytope.cc:110
setBlackboxStuff
int setBlackboxStuff(blackbox *bb, const char *n)
define a new type
Definition blackbox.cc:143
p
int p
Definition cfModGcd.cc:4086
b
CanonicalForm b
Definition cfModGcd.cc:4111
omAlloc0
#define omAlloc0(size)
Definition omAllocDecl.h:211

## getAmbientDimension()

int getAmbientDimension | ( | gfan::ZCone * | zc | ) |

Definition at line 386 of file bbpolytope.cc.

{ // hence ambientDimension-1
return zc->ambientDimension()-1;
}

## getCodimension()

int getCodimension | ( | gfan::ZCone * | zc | ) |

Definition at line 391 of file bbpolytope.cc.

{
return zc->codimension();
}

## getDimension()

int getDimension | ( | gfan::ZCone * | zc | ) |

Definition at line 396 of file bbpolytope.cc.

{
return zc->dimension()-1;
}

## getFacetNormals()

bigintmat * getFacetNormals | ( | gfan::ZCone * | zc | ) |

## intStar2ZVectorWithLeadingOne()

gfan::ZVector intStar2ZVectorWithLeadingOne | ( | const int | d,
|  | const int * | i )

Definition at line 401 of file bbpolytope.cc.

{
gfan::ZVector zv(d+1);
zv[0]=1;
for(int j=1; j<=d; j++)
{
zv[j]=i[j];
}
return zv;
}
i
int i
Definition cfEzgcd.cc:132
j
int j
Definition facHensel.cc:110

## Variable Documentation

## polytopeID

EXTERN_VAR int polytopeID

Definition at line 11 of file bbpolytope.h.